function LEM_show_STDL(airways,reservations,flights,f)
%

path = flights(f).path;
num_lanes = length(path);
lane_lengths = airways.lane_lengths;

clf
hold on
y1 = 0;

t1 = flights(f).start_time;
t2 = flights(f).end_time;

for k = 1:num_lanes
    lane_index = path(k);
    lane_flights = reservations(lane_index).flights;
    num_lane_flights = length(lane_flights(:,1));
    y2 = y1 + lane_lengths(lane_index);
    plot([t1,t2],[y1,y1],'b');
    for s = 1:num_lane_flights
        if lane_flights(s,1)==f
            plot(lane_flights(s,2:3),[y1,y2],'r');
        else
            if ~(lane_flights(s,2)>t2|lane_flights(s,3)<t1)
                plot(lane_flights(s,2:3),[y1,y2],'k');
            end
        end
    end
    y1 = y2;
end
